#include "nrf/nrutil.h"

class DataDesc;

class SPcgf : public CGFTargetFunc {
public:
	SPcgf(double** codebook, int ssize, int codebook_size, double lambda, double beta, double sigma, int outflag=0);
	~SPcgf(void);

	void cgf(double** P, DataDesc* X, double tol=0.001, int maxiter=100, int numflag=0);


	virtual float init_f1dim(float* s1, float* d1);
	virtual float f1dim(float alpha);
	virtual void dfunc(float* p,float* grad);

	virtual int ITMAX(void) { return itmax; }

private:

	double sparse(double x);
	double sparse_prime(double x);

	double *A;		// basis matrix
	int L;			// data dimension
	int M;			// number of basis vectors
	double lambda;		// 1/noise_var
	double beta;		// prior steepness
	double sigma;		// prior scaling
	double k1,k2,k3;	// precomputed constants for f1dim

	double *x;		// current data vector being fitted
	double *s0;		// init coefficient vector (1:M)
	double *d;		// search dir. coefficient vector (1:M)
	int outflag;		// print search progress

	double *AtA;		// Only compute A'*A once (1:M,1:M)
	double *Atx;		// A*x (1:M)

	int fcount, gcount;

	int itmax;


	void do_cgf(double *Sout, double *nits, double *nf, double *ng, 
		 double *Sin, double *X, int npats, 
		 double tol, int maxiter, int numflag);

	double** codebook;
};
