#include <math.h>
#include "nrutil.h"
#define GOLD 1.618034
#define GLIMIT 100.0
#define TINY 1.0e-20
#define SHFT(a,b,c,d) (a)=(b);(b)=(c);(c)=(d);

//void mnbrak(ax,bx,cx,fa,fb,fc,func)
//float (*func)(),*ax,*bx,*cx,*fa,*fb,*fc;

void mnbrak(float *ax, float* bx, float* cx, float* fa,float* fb,float* fc,CGFTargetFunc* tfunc) {

	float ulim,u,r,q,fu,dum;

	//*fa=(*func)(*ax);
	//*fb=(*func)(*bx);

	*fa=tfunc->f1dim(*ax);
	*fb=tfunc->f1dim(*bx);

	if (*fb > *fa) {
		SHFT(dum,*ax,*bx,dum)
		SHFT(dum,*fb,*fa,dum)
	}
	*cx=(*bx)+GOLD*(*bx-*ax);
	//*fc=(*func)(*cx);
	*fc=tfunc->f1dim(*cx);
	while (*fb > *fc) {
		r=(*bx-*ax)*(*fb-*fc);
		q=(*bx-*cx)*(*fb-*fa);
		u=(*bx)-((*bx-*cx)*q-(*bx-*ax)*r)/
			(2.0*SIGN(FMAX(fabs(q-r),TINY),q-r));
		ulim=(*bx)+GLIMIT*(*cx-*bx);
		if ((*bx-u)*(u-*cx) > 0.0) {
			//fu=(*func)(u);
			fu=tfunc->f1dim(u);
			if (fu < *fc) {
				*ax=(*bx);
				*bx=u;
				*fa=(*fb);
				*fb=fu;
				return;
			} else if (fu > *fb) {
				*cx=u;
				*fc=fu;
				return;
			}
			u=(*cx)+GOLD*(*cx-*bx);
			//fu=(*func)(u);
			fu=tfunc->f1dim(u);
		} else if ((*cx-u)*(u-ulim) > 0.0) {
			fu=tfunc->f1dim(u);
			if (fu < *fc) {
				SHFT(*bx,*cx,u,*cx+GOLD*(*cx-*bx))
				//SHFT(*fb,*fc,fu,(*func)(u))
				SHFT(*fb,*fc,fu,tfunc->f1dim(u))
			}
		} else if ((u-ulim)*(ulim-*cx) >= 0.0) {
			u=ulim;
			//fu=(*func)(u);
			fu=tfunc->f1dim(u);
		} else {
			u=(*cx)+GOLD*(*cx-*bx);
			//fu=(*func)(u);
			fu=tfunc->f1dim(u);
		}
		SHFT(*ax,*bx,*cx,u)
		SHFT(*fa,*fb,*fc,fu)
	}
}
#undef GOLD
#undef GLIMIT
#undef TINY
#undef SHFT
/* (C) Copr. 1986-92 Numerical Recipes Software 6=Mn.Y". */
