%
% Extract a number of random tiles out of a number of given images.
% The local mean pixel value is removed from each tile. Finally the mean over all extracted tiles is removed.
% (this preprocessing is also described in [1])
%
%function [T, global_mean] = RFE(IMAGES, image_width, image_height, tile_width, tile_height, number_of_random_tiles);
%
%Input:
%  IMAGES                 : matrix that contains images of size (image_width x image_height) as columns
%  image_width            : see above
%  image_height           : see above
%  tile_width             : width of random tiles that are extracted
%  tile_height            : height of random tiles that are extracted
%  number_of_random_tiles : number of tiles
%
%Output:
%  T           : matrix that contains the random tiles as columns
%  global_mean : the global mean over all tiles that has been removed from T
%
%-----------
%[1] Kai Labusch, Erhardt Barth, and Thomas Martinetz. Simple Method for High-Performance Digit Recognition Based on Sparse Coding. 
%    IEEE Transactions on Neural Networks, 19(11):1985-1989, 2008.
%
function [T, global_mean] = RFE(IMAGES, image_width, image_height, tile_width, tile_height, number_of_random_tiles);
