%
% Conjugate gradient minimization of the Sparsenet target function 
% implemented by Bruno Olshausen in the Sparsenet algorithm
% (https://redwood.berkeley.edu/bruno/sparsenet/). See also [1] and [2].
%
%function P=SPCGF(X, codebook, noise_var, beta, sigma, maxiter, tol);
%
%---------
%[1] Olshausen BA, Field DJ (1997). Sparse coding with an overcomplete
%    basis set: A strategy employed by V1?  Vision Research, 37, 3311-3325.
%    ftp://redwood.ucdavis.edu/pub/papers/VR.pdf
% 
%[2] Olshausen BA, Field DJ (1996). Emergence of simple-cell receptive
%    field properties by learning a sparse code for natural images.
%    Nature, 381, 607-609.
%    ftp://redwood.ucdavis.edu/pub/papers/nature-paper.pdf
%
%Input:
%  X : Data 
%  A : basis 
%  noise_var : variance of the noise (|x-As|^2)
%  beta      : steepness term for prior
%  sigma     : scaling term for prior
%  maxiter   : maximum number of CG minimization steps
%  tol       : solution tolerance (default 0.001)
%
%Output:
%  P : coefficients
%
function P=SPCGF(X, A, noise_var, beta, sigma, maxiter, tol)
